Imports UJ.ExceptionManagement
Imports UJ.ExceptionManagement.Classes     

'This class implements IAdditonalInfoProvider interface; EMS automatically calls this interface 
Public Class Account
  Implements IAdditionalInfoProvider  

  Public AccountNumber As String
  Public Balance As Double
  Public AccountType As String

  Public Sub New(ByVal acctNumber As String, ByVal acctType as String, ByVal acctBalance As Double)
    AccountNumber = acctNumber
    AccountType = acctType
    Balance = acctBalance
  End Sub

  Public Function AddBalance(ByVal amount As Double)
    Try
      'Let's say negative balances are not allowed
      Ems.Validate(Balance + amount >= 0, "Amount debited ({0}) exceeds account balance.", amount)
      Balance = Balance + amount
    Catch _ex As Exception
      'Notice, we don't provide account number value to Ems.HandleException. 
      'In the following call "Me" is Account object implementing IAdditionalInfoProvider interface; 
      'EMS will recognize this and retrieve account number automatically, so it will appear in validation message
      ' and in exception report.
      Ems.HandleException(Me, _ex, Ems.AsParams(amount))
      Throw
    End Try
  End Function

  Sub ProvideAdditonalInfo(instanceName as String, info as AdditionalInfoDictionary) Implements IAdditionalInfoProvider.ProvideAdditionalInfo 
    info.Add(instanceName, "AccountType", Me.AccountType) 
    info.Add(instanceName, "AccountNumber", Me.AccountNumber) 
    info.Add(instanceName, "AccountBalance", Me.Balance)
  End Sub 

End Class

