Imports System.Threading
Imports System.Runtime.Serialization
Imports UJ.ExceptionManagement

'This is main remote class. Application will create its instance in remote domain
Public Class RemoteClass
	Inherits MarshalByRefObject

	Public Sub New()
	End Sub

	Public Function GetDomainInfo() As String
		Return "Domain=" & AppDomain.CurrentDomain.FriendlyName & " Thread ID=" & _
				AppDomain.GetCurrentThreadId().ToString() & _
				" Context ID=" & Thread.CurrentContext.ContextID.ToString()
	End Function


    Public Sub RunDemo(ByVal ExceptionType As String)
        Dim vSerObj As SerClass = New SerClass
        Dim vNonSerObj As NonSerClass = New NonSerClass
        Dim vByRefObj As MarshByRefClass = New MarshByRefClass
        Try
            RunDemoInternal(ExceptionType, vSerObj, vNonSerObj, vByRefObj)
        Catch _ex As Exception
            Ems.HandleException(Me, _ex, Ems.AsParams(ExceptionType), _
              Ems.AsLocals("vSerObj,vNonSerObj,vByRefObj", vSerObj, vNonSerObj, vByRefObj))
        End Try
    End Sub

    Public Sub RunDemoInternal(ByVal ExceptionType As String, ByVal pSerObj As SerClass, ByVal pNonSerObj As NonSerClass, ByVal pByRefObj As MarshByRefClass)
        Try
          Dim msg As String = "Exception of type " + ExceptionType + " thrown in remote call."
          Dim exc as Exception 
          Select Case ExceptionType
            Case "ApplicationException"
              exc = New ApplicationException(msg)
            Case "FatalException"
              exc = New FatalException(msg)
            Case "ValidationException"
              exc = new ValidationException(msg)
            Case "CancelException"
              exc = New CancelException
            Case Else
              exc = New ApplicationException(msg)
          End Select
          Throw exc
        Catch _ex As Exception
            Ems.HandleException(Me, _ex, Ems.AsParams(ExceptionType, pSerObj, pNonSerObj, pByRefObj))
        End Try
    End Sub


End Class

<Serializable()> _
Public Class SerClass
  Public Overrides Function ToString() As String
    Return "(Serializable custom class)"
  End Function
End Class

Public Class NonSerClass
  Public Overrides Function ToString() As String
    Return "(Non-Serializable custom class)"
  End Function
End Class

Public Class MarshByRefClass
  Inherits MarshalByRefObject
  Public Overrides Function ToString() As String
    Return "(MarshalByRef custom class)"
  End Function
End Class


