Imports System.Windows.Forms
Imports UJ.Configuration 

<Flags>  _
public enum SampleEnum
  OptionOne = 1
  OptionTwo = 2
  OptionThree = 4
End Enum

Public Class SampleConfigurableClass
    Implements IConfigurable
    'Fields
    Private _owner As Form
    Private _configSection As ConfigurationSection
    Private _stringProperty As String
    Private _integerProperty As Integer
    Private _enumProperty as SampleEnum 

    Public ReadOnly Property Owner() As Form
        Get
            Return _owner
        End Get
    End Property


    Public Property StringProperty() As String
        Get
            Return _stringProperty
        End Get
        Set(ByVal Value As String)
            _stringProperty = Value
        End Set
    End Property

    Public Property IntegerProperty() As Integer
        Get
            Return _integerProperty
        End Get
        Set(ByVal Value As Integer)
            _integerProperty = Value
        End Set
    End Property

    public Property EnumProperty as SampleEnum 
      Get
        Return _enumProperty
      End Get
      Set (ByVal Value as SampleEnum)
        _enumProperty = Value 
      End Set
    End Property


    'note: IConfigurable interface is defined by EMS and is optional for your objects. 
    'Implement it if you want: 
    '  1. Provide "owner" or parent object to created object
    '  2. Provide created object with its configuration section, from which it was created. 

    Public Sub Configure(ByVal owner As Object, ByVal section As ConfigurationSection) Implements IConfigurable.Configure
        If TypeOf owner Is Form Then
            _owner = owner
        End If
        _configSection = section
    End Sub

    Public Overrides Function ToString() As String
      Dim s as String  = " IntegerProperty=" & IntegerProperty.ToString() & _
             "; StringProperty=" & StringProperty + "; EnumProperty=" + EnumProperty.ToString() 
      if not _owner is Nothing then 
        s = s + "; Owner form=[" + _owner.Text + "]"
      End If
      Return s
    End Function

End Class
